# -*- coding: UTF-8 -*-

import sys
from PIL import Image, ImageDraw
try:
    import psyco
    psyco.full()
except:
    print 'Warning : Unable to load psyco. The script will be slower.'


def borders(orig_image, th=0):
    orig_data = orig_image.getdata()
    orig_sizeX = orig_image.size[0]

    new_image = Image.new('RGB', orig_image.size)
    new_data = []

    print "PHASE 1 : Création de l'image"

    totalColor = 0
    maxColor = 0
    for i, pixel in enumerate(orig_data):
        color = 0
        for point in (i+1, i-1, i+orig_sizeX, i-orig_sizeX, i+orig_sizeX+1, i+orig_sizeX-1, i-orig_sizeX-1, i-orig_sizeX+1):
            try:
                point = orig_data[point]
            except:
                continue
            color += abs(point[0] - pixel[0])
            color += abs(point[1] - pixel[1])
            color += abs(point[2] - pixel[2])
        color = color / 24
        if color > maxColor:
            maxColor = color
        totalColor += color
        new_data.append((color, color, color))

    averageColor = totalColor * th / (new_image.size[0] * new_image.size[1])
    mulColor = 255 / float(maxColor)
    new_image.putdata(new_data)
    new_data = []

    print "PHASE 2 : Post-Traitement"

    for i, pixel in enumerate(new_image.getdata()):
        if th != 0:
            color = 0 if pixel[0] > averageColor or not (2 < i % orig_sizeX < orig_sizeX - 2) else 255
        else:
            color = 255 - int(pixel[0] * mulColor)
        new_data.append((color, color, color))

    new_image.putdata(new_data)
    return new_image


if __name__ == '__main__':
    orig_image = Image.open(' '.join(sys.argv[1:]))
    borders(orig_image, 0).show()

